import { useIntersectionObserver } from "@vueuse/core";
import { storeToRefs } from "pinia";
import { useMobileStore } from "src/stores/mobileNav";
import { onMounted, ref } from "vue";

export function useVerticalCarouselImgs() {
  const mobileStore = useMobileStore();
  const { screenWidth } = storeToRefs(mobileStore);
  const { handleResize } = mobileStore;

  const target = ref(null);
  const navPos = ref("bottom");
  const slide = ref("style");

  onMounted(() => {
    screenWidth.value = window.innerWidth;
  });

  useIntersectionObserver(target, ([{ isIntersecting }]) => {
    mobileStore.isCarouselVisible = isIntersecting;
  });
  document.addEventListener("resize", handleResize);

  return { screenWidth, navPos, slide, target };
}
